Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

Type

  { TDummy }

  TDummy = Class
  private
    fText: String;
  public
    Constructor create(); virtual;
    Procedure DialOut();
    Function Clone: TDummy; virtual;
  End;

  { TDummy1 }

  TDummy1 = Class(TDummy)
  private
  public
    Constructor create(); override;
    //Function Clone: TDummy; override;
  End;

  { TDummy2 }

  TDummy2 = Class(TDummy)
  private
  public
    Constructor create(); override;
    //Function Clone: TDummy; override;
  End;

  { TDummy3 }

  TDummy3 = Class(TDummy1)
  private
  public
    Constructor create(); override;
    //Function Clone: TDummy; override;
  End;

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    Talker: TDummy;
    RegisteredClasses: Array Of TClass;
    RegisteredClasses2: Array Of TDummy;
    Procedure RegisterClass(Class_: TClass; Name_: String);
    Procedure RegisterClass2(Class_: TDummy; Name_: String);
  End;

Var
  Form1: TForm1;

Implementation

{ TDummy3 }

Constructor TDummy3.create;
Begin
  Inherited create;
  ftext := 'TDummy3';
End;

//Function TDummy3.Clone: TDummy;
//Begin
//  Result := TDummy3.create();
//End;


{ TDummy2 }

Constructor TDummy2.create;
Begin
  Inherited create;
  ftext := 'TDummy2';
End;

//Function TDummy2.Clone: TDummy;
//Begin
//  Result := TDummy2.create();
//End;

{ TDummy1 }

Constructor TDummy1.create;
Begin
  Inherited create;
  ftext := 'TDummy1';
End;

//Function TDummy1.Clone: TDummy;
//Begin
//  Result := TDummy1.create();
//End;

{ TDummy }

Constructor TDummy.create;
Begin
  ftext := 'TDummy';
End;

Procedure TDummy.DialOut;
Begin
  ShowMessage(ftext);
End;

Function TDummy.Clone: TDummy;
Begin
  result := TDummy.create();
End;

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  ComboBox1.Clear;
  Talker := Nil;
  RegisterClass(TDummy1, 'Dummy1');
  RegisterClass(TDummy2, 'Dummy2');
  RegisterClass(TDummy3, 'Dummy3');
  RegisterClass2(TDummy1.create, 'Dummy1');
  RegisterClass2(TDummy2.create, 'Dummy2');
  RegisterClass2(TDummy3.create, 'Dummy3');
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  If ComboBox1.ItemIndex <> -1 Then Begin
    If assigned(Talker) Then Talker.free;
    (*
     * Dieses Case will ich mittels des RegisteredClasses Array's realisieren, geht das ?
     *)
    Case ComboBox1.ItemIndex Of
      0: talker := TDummy1.create();
      1: talker := TDummy2.create();
      2: talker := TDummy3.create();
    End;
    (*
      talker := RegisteredClasses[0].Create As TDummy; // Das hier geht leider nicht
     *)
    talker.DialOut();
  End;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  If ComboBox1.ItemIndex <> -1 Then Begin
    If assigned(Talker) Then Talker.free;
    (*
     * Das Clone geht leider auch nicht, da es ja immer eine Instanz von TDummy erzeugt und nicht von TdummyX
     *)
    Talker := RegisteredClasses2[ComboBox1.ItemIndex].Clone;
    talker.DialOut();
  End;
End;

Procedure TForm1.Button3Click(Sender: TObject);
Begin
  close;
End;

Procedure TForm1.FormCloseQuery(Sender: TObject; Var CanClose: boolean);
Var
  i: integer;
Begin
  If assigned(talker) Then talker.free;
  talker := Nil;
  For i := 0 To high(RegisteredClasses2) Do
    RegisteredClasses2[i].free;
  setlength(RegisteredClasses, 0);
  setlength(RegisteredClasses2, 0);
End;

Procedure TForm1.RegisterClass(Class_: TClass; Name_: String);
Begin
  setlength(RegisteredClasses, high(RegisteredClasses) + 2);
  RegisteredClasses[high(RegisteredClasses)] := class_;
  ComboBox1.Items.Add(name_);
End;

Procedure TForm1.RegisterClass2(Class_: TDummy; Name_: String);
Begin
  setlength(RegisteredClasses2, high(RegisteredClasses2) + 2);
  RegisteredClasses2[high(RegisteredClasses2)] := class_;
End;

End.

